<?php
/*
  This code is part of GOsa (https://gosa.gonicus.de)
  Copyright (C) 2003  Cajus Pollmeier

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

class dhcptabs extends tabs
{
  var $parent= NULL;

  function dhcptabs($config, $data, $dn, $parent= NULL)
  {
  	$this->parent= $parent;
	tabs::tabs($config, $data, $dn);
  }

  function save_object($save_current= FALSE)
  {
        tabs::save_object($save_current);

	/* First object is the one we need */
	$baseobject= NULL;
	foreach ($this->by_object as $basename => $obj){
		if ($baseobject == NULL){
			$baseobject= $obj;
			break;
		}
	}

	/* Transfer options and statements to base object if needed */
	if ($this->last == "dhcpNetwork" || $this->last == "dhcpAdvanced"){
		$baseobject->options= $this->by_object[$this->last]->options;
		$baseobject->statements= $this->by_object[$this->last]->statements;
		$baseobject->parent= &$this;
		$this->by_object[$basename]= $baseobject;
	}

	/* Distribute to other objects */
        foreach ($this->by_object as $name => $obj){
                /* Don't touch base object */
                if ($name != $basename){
                        $obj->parent= &$this;
                        $obj->options= $baseobject->options;
                        $obj->statements= $baseobject->statements;
                        $this->by_object[$name]= $obj;
                }
        }

  }

}

?>
